<%@ include file="includes/jspheader.jsp" %>
<%@ include file="includes/jspencoding.jsp" %>
<%@ include file="includes/sdkinit.jsp" %>
<%@ include file="includes/sdklogincheck.jsp" %>

<%@ page import="com.esko.util.*" %>
<%@ page import="com.esko.webcenter.chili.*" %>
<%@ page import="com.esko.webcenter.log.*" %>
<%@ page import="com.esko.webcenter.servlets.*"%>
<%@ page import="com.esko.webcenter.src.root.view.DocVersionView"%>
<%@page import="com.esko.webcenter.jsp.helper.DocumentActionsHelper"%>


<%@ page import="java.util.*" %>
<%@ page import="java.sql.Timestamp" %>

<%
	// === Start of the main scriplet ===
	String loginID = LoginMgr.getLoginMgr(session).getLoginID() ; 

	// get parameters 	
	Properties requestParams = SDKUtils.getRequestParams(request, session, application, requestParamsLoginCheck);
	String action = (requestParams.containsKey("action")) ? ((String[])requestParams.get("action"))[0] : null;
	String docVerId = (requestParams.containsKey("docverid")) ? ((String[])requestParams.get("docverid"))[0] : null;
	String getDocAttr = (requestParams.containsKey("getdocattr")) ? ((String[])requestParams.get("getdocattr"))[0] : null;
	String getProjAttr = (requestParams.containsKey("getprojattr")) ? ((String[])requestParams.get("getprojattr"))[0] : null;
	String requestStampStr = (requestParams.containsKey("timestamp")) ? ((String[])requestParams.get("timestamp"))[0] : null;
	if(!StringUtils.checkForValue(action)){
		out.write(SDKUtils.ShowError(SDKUtils.SDK_PARAM_MISSING));
		checkLogOff(session);
		return;
	}
	 
	if(action.equalsIgnoreCase("savedraft")){
		if(!StringUtils.checkForValue(docVerId)){
			out.write(SDKUtils.ShowError(SDKUtils.SDK_PARAM_MISSING));
			checkLogOff(session);
			return;
		}
		// create the EJBs
		CHILI chili = DBTMUtils.findBean(response, session, CHILI.class);
		if (chili == null) {
			out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR));
			checkLogOff(session);		
			return;
		}
		
		try {
			boolean retval = chili.saveAsDraft(loginID, docVerId);
%>
	<actionresponse>
		<result><%= retval?"1":"0" %></result>
	</actionresponse>
<%

	}catch (WebCenterRemoteException ex) {
		LogMgr.getLogger().log(Level.SEVERE, "Error in CHILIActions.jsp: CHILI.saveAsDraft Details: " + ex.toString());
		out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ex));
		checkLogOff(session);
		return;
	}
	} else if(action.equalsIgnoreCase("getmodifiedxml")){
		if(!StringUtils.checkForValue(docVerId)){
			out.write(SDKUtils.ShowError(SDKUtils.SDK_PARAM_MISSING));
			checkLogOff(session);
			return;
		}
		// create the EJBs
		CHILI chili = DBTMUtils.findBean(response, session, CHILI.class);
		if (chili == null) {
			out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR));
			checkLogOff(session);		
			return;
		}
		
		//find out which variables should be updated
		boolean getdocAttributes = getDocAttr!=null && getDocAttr.equals("1");
		boolean getprojectAttributes = getProjAttr!=null && getProjAttr.equals("1");
		
		try {
			String modifiedXml = chili.getModifiedVariableXml(loginID, docVerId, getdocAttributes, getprojectAttributes);
%>
<%= modifiedXml==null?"<novariablematches/>":modifiedXml %>
<%

		}catch (WebCenterRemoteException ex) {
			LogMgr.getLogger().log(Level.SEVERE, "Error in CHILIActions.jsp: CHILI.getModifiedVariableXml Details: " + ex.toString());
			out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ex));
			checkLogOff(session);
			return;
		}
	}  else if(action.equalsIgnoreCase("exiteditor")){
		if(!StringUtils.checkForValue(docVerId)){
			out.write(SDKUtils.ShowError(SDKUtils.SDK_PARAM_MISSING));
			checkLogOff(session);
			return;
		}
	
		try {
			Object object = CHILIConst.getToken(docVerId);
			if(object!=null){
				DocumentUtils.unlockCHILIDocument(session, response, loginID, LoginMgr.getLoginMgr(session).getLoginUserID(), null, docVerId);
			}
%>
	<actionresponse>
		<result>1</result>
	</actionresponse>
<%

		}catch (WebCenterRemoteException ex) {
			LogMgr.getLogger().log(Level.SEVERE, "Error in CHILIActions.jsp: DocumentActionsHelper.unlockCHILIDocument Details: " + ex.toString());
			out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ex));
			checkLogOff(session);
			return;
		}
	}  else if(action.equalsIgnoreCase("prepareexiteditor")){
		if(!StringUtils.checkForValue(docVerId)){
			out.write(SDKUtils.ShowError(SDKUtils.SDK_PARAM_MISSING));
			checkLogOff(session);
			return;
		}
		
		
		CHILIConst.setToken(docVerId, new Date().getTime());
		
%>
<actionresponse>
	<result>1</result>
</actionresponse>
<%

	}  else if(action.equalsIgnoreCase("getimagexml")){
		try{
		if(!StringUtils.checkForValue(docVerId)){
			out.write(SDKUtils.ShowError(SDKUtils.SDK_PARAM_MISSING));
			checkLogOff(session);
			return;
		}
		
		DocumentMgrTM documentMgrTM = DBTMUtils.findBean(response, session, DocumentMgrTM.class);
		DocVersionView docVersionView = documentMgrTM.loadDocVersionViewById(LoginMgr.getLoginMgr(session).getLoginID(), docVerId, true);
		String docName = docVersionView.getDoc().getName();
		//Target path format will be "dv_[7igitsof docversionID after underscore]/docversionID
		//E.g dv_0000078/0002_0000078003
		String targetPath = "dv_"+docVerId.substring(docVerId.lastIndexOf("_") + 1, docVerId.lastIndexOf("_") + 8) + "/"	+ docVerId;
		
		// get thumbnail URL
		String docThumbUrl = StringUtils.checkForValue(docVersionView.getDoc().getEncodedThumbnailUrl()) ?
			DocThumbnailStreamer.docThumbnailStreamURL(session, docVersionView.getDoc()) :
			ConfigurationMgr.getInstance().getDefDocThumbURL(docName);
		String fullDocUrl = ServletUtil.generateFullContextPath(request)+docThumbUrl;
		
		Vector<Project> projects = documentMgrTM.getDocVersionProjectList(LoginMgr.getLoginMgr(session).getLoginID(),
				docVerId, true);
		Vector<Project> templates = documentMgrTM.getDocVersionProjectList(LoginMgr.getLoginMgr(session).getLoginID(),
				docVerId, false);
		projects.addAll(templates);
		
		// get download URL
		String docUrl = TempDownload.generateUserTempDownloadUrl(request, projects.get(0).getObjectID(), docVerId, true);		
%>
<actionresponse>
	<result>
		<item id="<%= XMLUtils.safeEncodeXml(docVerId) %>" 
				name="<%= XMLUtils.safeEncodeXml(docName) %>"
				fileName="<%= XMLUtils.safeEncodeXml(docName) %>"
				remoteURL="<%= XMLUtils.safeEncodeXml(docUrl) %>"
				thumb="<%= XMLUtils.safeEncodeXml(fullDocUrl) %>"
				targetPath="<%= XMLUtils.safeEncodeXml(targetPath) %>"
				reuseExisting="true"	/>
	</result>
</actionresponse>
<%

		} catch(Exception ex){
			ex.printStackTrace();
%>
<actionresponse>
	<result>0</result>
</actionresponse>
<%
		}
		
	}  else if(action.equalsIgnoreCase("UploadNewChiliDocVersion")){
		try{
			String checkinComments = (requestParams.containsKey("docdesc")) ? ((String[])requestParams.get("docdesc"))[0] : null;
			String appCycleFlag = (requestParams.containsKey("startapproval")) ? ((String[])requestParams.get("startapproval"))[0] : null;
			String incrementRevision = (requestParams.containsKey("incrementrevision")) ? ((String[])requestParams.get("incrementrevision"))[0] : null;
			String longFormatDueDate = (requestParams.containsKey("duedate")) ? ((String[])requestParams.get("duedate"))[0] : null;
			String due_periodOfDay = (requestParams.containsKey("duedatehour")) ? ((String[])requestParams.get("duedatehour"))[0] : null;
			Timestamp duedate = DateUtils.calculateDateFromForm(session, longFormatDueDate, due_periodOfDay);
			
			// get projects
			DocumentMgrTM documentMgrTM = DBTMUtils.findBean(response, session, DocumentMgrTM.class);
			Vector<String> projectIds = new Vector<String>();
			Vector<Project> projects = documentMgrTM.getDocVersionProjectList(LoginMgr.getLoginMgr(session).getLoginID(),
				docVerId, true);
			Vector<Project> templates = documentMgrTM.getDocVersionProjectList(LoginMgr.getLoginMgr(session).getLoginID(),
					docVerId, false);
			projects.addAll(templates);
			
			// only add selected projects for linked documents?
			for(Project project : projects){
				projectIds.add(project.getObjectID());
			}

			DocumentActionsHelper helper = new DocumentActionsHelper(response, request, session, application, null, null);
			String newDocVerID = helper.uploadCHILIDocumentAsNewVersion(docVerId, null, null, null, projectIds, "true".equals(appCycleFlag),
					"true".equals(incrementRevision), duedate, false, false, checkinComments);
			
			if(!StringUtils.checkForValue(newDocVerID)){
				newDocVerID = "0";
			}
%>
<actionresponse>
	<result><%= newDocVerID %></result>
</actionresponse>
<%
		} catch (WebCenterRemoteException ex){
			ex.printStackTrace();
%>
<actionresponse>
	<error><%= XMLUtils.safeEncodeXml(ex.getLocalizedMessage()) %></error>
	<result>0</result>
</actionresponse>
<%	
		} catch (Exception ex){
			ex.printStackTrace();
%>
<actionresponse>
	<error><%= XMLUtils.safeEncodeXml(ex.getMessage()) %></error>
	<result>0</result>
</actionresponse>
<%	
		}
		
	}

	
	checkLogOff(session);
%>
